module.exports = {
    extends: [
        'plugin:@typescript-eslint/recommended', // Uses the recommended rules from the @typescript-eslint/eslint-plugin
        '@gaoding/eslint-config-base',
    ],
    parserOptions: {
        parser: '@typescript-eslint/parser',
        ecmaVersion: 2018, // Allows for the parsing of modern ECMAScript features
        sourceType: 'module', // Allows for the use of imports
    },
    rules: {
        "@typescript-eslint/interface-name-prefix": [true, "always-prefix"],
        "@typescript-eslint/explicit-member-accessibility": false,
        "@typescript-eslint/explicit-function-return-type": false,
        "@typescript-eslint/no-non-null-assertion": false,
        "@typescript-eslint/camelcase": false,
        "@typescript-eslint/no-explicit-any": false,

        // 禁止对对象文本进行类型断言
        "@typescript-eslint/no-object-literal-type-assertion": false,
        // 禁止空成员的接口定义
        "@typescript-eslint/no-empty-interface": false,

        // await 可以直接 return
        "no-return-await": 0,
        // 和 typescript-eslint 冲突
        "no-unused-vars": 0,
        // 代码块花括号可以不换行
        "brace-style": 0,

        "camelcase": 0,
        // 和 typescript-eslint 冲突
        "indent": 0,
        'keyword-spacing': ['error', {
            before: true,
            after: true,
            overrides: {
              return: { after: true },
              throw: { after: true },
              case: { after: true }
            }
        }],
    },
};